% This version initializes V by the unconstrained value

function [xgrid,sgrid,Vinit]=fun(dx,ds,xmin,xmax,smax,alpha,sigma,rho,lamda,cost);


beta=1/2-alpha/(sigma^2)-sqrt((alpha/(sigma^2)-1/2)^2+2*(rho+lamda)/(sigma^2));
ystar=(beta/(beta-1))*((rho+lamda)-alpha)*(cost/(rho+lamda)); %unconstrained exit threshold (y~GBM(alpha,sigma))

% XGrid - a grid with even spaces
xgrid=(-(ceil(-xmin/dx))*dx:dx:xmax); % Include x=0 in the grid! 
%XN=size(xgrid,2);
%xzeroind=1;for xind=1:XN,if xgrid(xind)<=0,xzeroind=xind;end;end 

% SGrid
sgrid=(0:ds:smax+ds);
%SN=size(sgrid,2);

XN=size(xgrid,2);SN=size(sgrid,2);


% VT - initial V
Vinit=zeros(SN,XN);
for i=1:XN,
    Vinit(:,i)=sgrid';
end
    
% add these to get unconstrained values as initial values:

for xind=1:XN,
    if exp(xgrid(xind))>ystar,
%        Vinit(:,xind)=sgrid'+exp(xgrid(xind))/(rho+lamda-alpha)-cost/(rho+lamda)-(ystar/(beta*(rho+lamda-alpha)))*(exp(xgrid(xind))/ystar)^beta;
        Vinit(:,xind)=sgrid'+exp(xgrid(xind))/(rho+lamda-alpha)-cost/(rho+lamda)+(cost/(rho+lamda)-ystar/(rho+lamda-alpha))*(exp(xgrid(xind))/ystar)^beta;
    end
end
